kubectl apply -k ./setup

kubectl wait --for=condition=ready --timeout=1m pod -l app=nsc-kernel -n ns-2registry3nsexnsc
kubectl wait --for=condition=ready --timeout=1m pod -l app=nse-kernel-1 -n ns-2registry3nsexnsc

rm -rf traces
mkdir traces

for i in {1..5}; do
    echo "Attempt #$i"

    fwds=$(kubectl get pods -l app=forwarder-vpp -n nsm-system --template '{{range .items}}{{.metadata.name}}{{"\n"}}{{end}}')

    for fwd in $fwds; do
        kubectl exec -n nsm-system $fwd -- vppctl api trace free
        kubectl exec -n nsm-system $fwd -- vppctl api trace on
    done

    sleep 10

    kubectl scale deployment -n ns-2registry3nsexnsc nsc-kernel --replicas=30;
    kubectl scale deployment -n ns-2registry3nsexnsc nse-kernel-1 --replicas=30;
    sleep 40

    for fwd in $fwds; do
        dir=traces/attempt$i/$fwd
        mkdir -p $dir
        kubectl exec -n nsm-system $fwd -- vppctl show int > $dir/ifaces-before
    done

    kubectl scale deployment -n ns-2registry3nsexnsc nsc-kernel --replicas=0;
    kubectl scale deployment -n ns-2registry3nsexnsc nse-kernel-1 --replicas=0;
    sleep 30

    for fwd in $fwds; do
        dir=traces/attempt$i/$fwd
        kubectl exec -n nsm-system $fwd -- vppctl api trace dump > $dir/dump.api
        kubectl exec -n nsm-system $fwd -- vppctl show int > $dir/ifaces-after
    done
done
