delete() {
    docker restart "kind-worker"
}

ping() {
    result=0
    nscs=$(kubectl get pods -l app=nsc-kernel -o go-template --template="{{range .items}}{{.metadata.name}} {{end}}" -n ns-2registry3nsexnsc)
    for nsc in $nscs; do
        ipv4=$(kubectl exec $nsc -n ns-2registry3nsexnsc -- ip route show dev nsm-v4 | cut -d' ' -f1 | tr '\n' ' ' | cut -d' ' -f1)
        kubectl exec $nsc -n ns-2registry3nsexnsc -- ping -c2 -i0.5 $ipv4 2>&1 > error
        if [[ "$?" != 0 ]]; then
            echo "failed to ping from $nsc"
            echo "address: $ipv4"
            echo "date: $(date)"
            echo "Error:"
            cat error
            result=1
        fi
    done

    return $result
}

for i in {1..50}; do
    echo "Attempt #$i"
    delete
    date
    sleep 110
    ping

    if [[ "$?" != 0 ]]; then
        echo "failed to ping"
        read -p "Press any key to continue"
    fi 
    echo ""
    echo ""
done